Index: include/avr/iom64.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom64.h,v
retrieving revision 1.19
diff -u -r1.19 iom64.h
--- include/avr/iom64.h	17 Oct 2008 23:22:43 -0000	1.19
+++ include/avr/iom64.h	26 Mar 2009 20:10:32 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Steinar Haugen
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -361,138 +362,172 @@
 /* Interrupt vectors */
 
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* External Interrupt Request 2 */
+#define INT2_num 			3
 #define INT2_vect			_VECTOR(3)
 #define SIG_INTERRUPT2			_VECTOR(3)
 
 /* External Interrupt Request 3 */
+#define INT3_num 			4
 #define INT3_vect			_VECTOR(4)
 #define SIG_INTERRUPT3			_VECTOR(4)
 
 /* External Interrupt Request 4 */
+#define INT4_num 			5
 #define INT4_vect			_VECTOR(5)
 #define SIG_INTERRUPT4			_VECTOR(5)
 
 /* External Interrupt Request 5 */
+#define INT5_num 			6
 #define INT5_vect			_VECTOR(6)
 #define SIG_INTERRUPT5			_VECTOR(6)
 
 /* External Interrupt Request 6 */
+#define INT6_num 			7
 #define INT6_vect			_VECTOR(7)
 #define SIG_INTERRUPT6			_VECTOR(7)
 
 /* External Interrupt Request 7 */
+#define INT7_num 			8
 #define INT7_vect			_VECTOR(8)
 #define SIG_INTERRUPT7			_VECTOR(8)
 
 /* Timer/Counter2 Compare Match */
+#define TIMER2_COMP_num 		9
 #define TIMER2_COMP_vect		_VECTOR(9)
 #define SIG_OUTPUT_COMPARE2		_VECTOR(9)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			10
 #define TIMER2_OVF_vect			_VECTOR(10)
 #define SIG_OVERFLOW2			_VECTOR(10)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		11
 #define TIMER1_CAPT_vect		_VECTOR(11)
 #define SIG_INPUT_CAPTURE1		_VECTOR(11)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		12
 #define TIMER1_COMPA_vect		_VECTOR(12)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(12)
 
 /* Timer/Counter Compare Match B */
+#define TIMER1_COMPB_num 		13
 #define TIMER1_COMPB_vect		_VECTOR(13)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(13)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			14
 #define TIMER1_OVF_vect			_VECTOR(14)
 #define SIG_OVERFLOW1			_VECTOR(14)
 
 /* Timer/Counter0 Compare Match */
+#define TIMER0_COMP_num 		15
 #define TIMER0_COMP_vect		_VECTOR(15)
 #define SIG_OUTPUT_COMPARE0		_VECTOR(15)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			16
 #define TIMER0_OVF_vect			_VECTOR(16)
 #define SIG_OVERFLOW0			_VECTOR(16)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num 			17
 #define SPI_STC_vect			_VECTOR(17)
 #define SIG_SPI				_VECTOR(17)
 
 /* USART0, Rx Complete */
+#define USART0_RX_num 			18
 #define USART0_RX_vect			_VECTOR(18)
 #define SIG_UART0_RECV			_VECTOR(18)
 
 /* USART0 Data Register Empty */
+#define USART0_UDRE_num 		19
 #define USART0_UDRE_vect		_VECTOR(19)
 #define SIG_UART0_DATA			_VECTOR(19)
 
 /* USART0, Tx Complete */
+#define USART0_TX_num 			20
 #define USART0_TX_vect			_VECTOR(20)
 #define SIG_UART0_TRANS			_VECTOR(20)
 
 /* ADC Conversion Complete */
+#define ADC_num 			21
 #define ADC_vect			_VECTOR(21)
 #define SIG_ADC				_VECTOR(21)
 
 /* EEPROM Ready */
+#define EE_READY_num 			22
 #define EE_READY_vect			_VECTOR(22)
 #define SIG_EEPROM_READY		_VECTOR(22)
 
 /* Analog Comparator */
+#define ANALOG_COMP_num 		23
 #define ANALOG_COMP_vect		_VECTOR(23)
 #define SIG_COMPARATOR			_VECTOR(23)
 
 /* Timer/Counter1 Compare Match C */
+#define TIMER1_COMPC_num 		24
 #define TIMER1_COMPC_vect		_VECTOR(24)
 #define SIG_OUTPUT_COMPARE1C		_VECTOR(24)
 
 /* Timer/Counter3 Capture Event */
+#define TIMER3_CAPT_num 		25
 #define TIMER3_CAPT_vect		_VECTOR(25)
 #define SIG_INPUT_CAPTURE3		_VECTOR(25)
 
 /* Timer/Counter3 Compare Match A */
+#define TIMER3_COMPA_num 		26
 #define TIMER3_COMPA_vect		_VECTOR(26)
 #define SIG_OUTPUT_COMPARE3A		_VECTOR(26)
 
 /* Timer/Counter3 Compare Match B */
+#define TIMER3_COMPB_num 		27
 #define TIMER3_COMPB_vect		_VECTOR(27)
 #define SIG_OUTPUT_COMPARE3B		_VECTOR(27)
 
 /* Timer/Counter3 Compare Match C */
+#define TIMER3_COMPC_num 		28
 #define TIMER3_COMPC_vect		_VECTOR(28)
 #define SIG_OUTPUT_COMPARE3C		_VECTOR(28)
 
 /* Timer/Counter3 Overflow */
+#define TIMER3_OVF_num 			29
 #define TIMER3_OVF_vect			_VECTOR(29)
 #define SIG_OVERFLOW3			_VECTOR(29)
 
 /* USART1, Rx Complete */
+#define USART1_RX_num 			30
 #define USART1_RX_vect			_VECTOR(30)
 #define SIG_UART1_RECV			_VECTOR(30)
 
 /* USART1, Data Register Empty */
+#define USART1_UDRE_num 		31
 #define USART1_UDRE_vect		_VECTOR(31)
 #define SIG_UART1_DATA			_VECTOR(31)
 
 /* USART1, Tx Complete */
+#define USART1_TX_num 			32
 #define USART1_TX_vect			_VECTOR(32)
 #define SIG_UART1_TRANS			_VECTOR(32)
 
 /* 2-wire Serial Interface */
+#define TWI_num 			33
 #define TWI_vect			_VECTOR(33)
 #define SIG_2WIRE_SERIAL		_VECTOR(33)
 
 /* Store Program Memory Read */
+#define SPM_READY_num 			34
 #define SPM_READY_vect			_VECTOR(34)
 #define SIG_SPM_READY			_VECTOR(34)
 
@@ -1224,4 +1259,326 @@
 #define SIGNATURE_2 0x02
 
 
+/* Device Pin Definitions */
+#define DDR_AD0  	DDRA
+#define PORT_AD0 	PORTA
+#define PIN_AD0  	PINA
+#define AD0_IDX  	0
+
+#define DDR_AD1  	DDRA
+#define PORT_AD1 	PORTA
+#define PIN_AD1  	PINA
+#define AD1_IDX  	1
+
+#define DDR_AD2  	DDRA
+#define PORT_AD2 	PORTA
+#define PIN_AD2  	PINA
+#define AD2_IDX  	2
+
+#define DDR_AD3  	DDRA
+#define PORT_AD3 	PORTA
+#define PIN_AD3  	PINA
+#define AD3_IDX  	3
+
+#define DDR_AD4  	DDRA
+#define PORT_AD4 	PORTA
+#define PIN_AD4  	PINA
+#define AD4_IDX  	4
+
+#define DDR_AD5  	DDRA
+#define PORT_AD5 	PORTA
+#define PIN_AD5  	PINA
+#define AD5_IDX  	5
+
+#define DDR_AD6  	DDRA
+#define PORT_AD6 	PORTA
+#define PIN_AD6  	PINA
+#define AD6_IDX  	6
+
+#define DDR_AD7  	DDRA
+#define PORT_AD7 	PORTA
+#define PIN_AD7  	PINA
+#define AD7_IDX  	7
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	0
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	1
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	2
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	3
+
+#define DDR_OC0  	DDRB
+#define PORT_OC0 	PORTB
+#define PIN_OC0  	PINB
+#define OC0_IDX  	4
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	5
+
+#define DDR_PWM1A  	DDRB
+#define PORT_PWM1A 	PORTB
+#define PIN_PWM1A  	PINB
+#define PWM1A_IDX  	5
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	6
+
+#define DDR_PWM1B  	DDRB
+#define PORT_PWM1B 	PORTB
+#define PIN_PWM1B  	PINB
+#define PWM1B_IDX  	6
+
+#define DDR_OC2  	DDRB
+#define PORT_OC2 	PORTB
+#define PIN_OC2  	PINB
+#define OC2_IDX  	7
+
+#define DDR_OC1C  	DDRB
+#define PORT_OC1C 	PORTB
+#define PIN_OC1C  	PINB
+#define OC1C_IDX  	7
+
+#define DDR_A8  	DDRC
+#define PORT_A8 	PORTC
+#define PIN_A8  	PINC
+#define A8_IDX  	0
+
+#define DDR_A9  	DDRC
+#define PORT_A9 	PORTC
+#define PIN_A9  	PINC
+#define A9_IDX  	1
+
+#define DDR_A10  	DDRC
+#define PORT_A10 	PORTC
+#define PIN_A10  	PINC
+#define A10_IDX  	2
+
+#define DDR_A11  	DDRC
+#define PORT_A11 	PORTC
+#define PIN_A11  	PINC
+#define A11_IDX  	3
+
+#define DDR_A12  	DDRC
+#define PORT_A12 	PORTC
+#define PIN_A12  	PINC
+#define A12_IDX  	4
+
+#define DDR_A13  	DDRC
+#define PORT_A13 	PORTC
+#define PIN_A13  	PINC
+#define A13_IDX  	5
+
+#define DDR_A14  	DDRC
+#define PORT_A14 	PORTC
+#define PIN_A14  	PINC
+#define A14_IDX  	6
+
+#define DDR_A15  	DDRC
+#define PORT_A15 	PORTC
+#define PIN_A15  	PINC
+#define A15_IDX  	7
+
+#define DDR_SCL  	DDRD
+#define PORT_SCL 	PORTD
+#define PIN_SCL  	PIND
+#define SCL_IDX  	0
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	0
+
+#define DDR_SDA  	DDRD
+#define PORT_SDA 	PORTD
+#define PIN_SDA  	PIND
+#define SDA_IDX  	1
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	1
+
+#define DDR_RXD1  	DDRD
+#define PORT_RXD1 	PORTD
+#define PIN_RXD1  	PIND
+#define RXD1_IDX  	2
+
+#define DDR_INT2  	DDRD
+#define PORT_INT2 	PORTD
+#define PIN_INT2  	PIND
+#define INT2_IDX  	2
+
+#define DDR_TXD1  	DDRD
+#define PORT_TXD1 	PORTD
+#define PIN_TXD1  	PIND
+#define TXD1_IDX  	3
+
+#define DDR_INT3  	DDRD
+#define PORT_INT3 	PORTD
+#define PIN_INT3  	PIND
+#define INT3_IDX  	3
+
+#define DDR_IC1  	DDRD
+#define PORT_IC1 	PORTD
+#define PIN_IC1  	PIND
+#define IC1_IDX  	4
+
+#define DDR_XCK1  	DDRD
+#define PORT_XCK1 	PORTD
+#define PIN_XCK1  	PIND
+#define XCK1_IDX  	5
+
+#define DDR_T1  	DDRD
+#define PORT_T1 	PORTD
+#define PIN_T1  	PIND
+#define T1_IDX  	6
+
+#define DDR_T2  	DDRD
+#define PORT_T2 	PORTD
+#define PIN_T2  	PIND
+#define T2_IDX  	7
+
+#define DDR_RXD0  	DDRE
+#define PORT_RXD0 	PORTE
+#define PIN_RXD0  	PINE
+#define RXD0_IDX  	0
+
+#define DDR_TXD0  	DDRE
+#define PORT_TXD0 	PORTE
+#define PIN_TXD0  	PINE
+#define TXD0_IDX  	1
+
+#define DDR_XCK0  	DDRE
+#define PORT_XCK0 	PORTE
+#define PIN_XCK0  	PINE
+#define XCK0_IDX  	2
+
+#define DDR_AIN0  	DDRE
+#define PORT_AIN0 	PORTE
+#define PIN_AIN0  	PINE
+#define AIN0_IDX  	2
+
+#define DDR_OC3A  	DDRE
+#define PORT_OC3A 	PORTE
+#define PIN_OC3A  	PINE
+#define OC3A_IDX  	3
+
+#define DDR_AIN1  	DDRE
+#define PORT_AIN1 	PORTE
+#define PIN_AIN1  	PINE
+#define AIN1_IDX  	3
+
+#define DDR_OC3B  	DDRE
+#define PORT_OC3B 	PORTE
+#define PIN_OC3B  	PINE
+#define OC3B_IDX  	4
+
+#define DDR_INT4  	DDRE
+#define PORT_INT4 	PORTE
+#define PIN_INT4  	PINE
+#define INT4_IDX  	4
+
+#define DDR_OC3C  	DDRE
+#define PORT_OC3C 	PORTE
+#define PIN_OC3C  	PINE
+#define OC3C_IDX  	5
+
+#define DDR_INT5  	DDRE
+#define PORT_INT5 	PORTE
+#define PIN_INT5  	PINE
+#define INT5_IDX  	5
+
+#define DDR_T3  	DDRE
+#define PORT_T3 	PORTE
+#define PIN_T3  	PINE
+#define T3_IDX  	6
+
+#define DDR_INT6  	DDRE
+#define PORT_INT6 	PORTE
+#define PIN_INT6  	PINE
+#define INT6_IDX  	6
+
+#define DDR_IC3  	DDRE
+#define PORT_IC3 	PORTE
+#define PIN_IC3  	PINE
+#define IC3_IDX  	7
+
+#define DDR_INT7  	DDRE
+#define PORT_INT7 	PORTE
+#define PIN_INT7  	PINE
+#define INT7_IDX  	7
+
+#define DDR_ADC0  	DDRF
+#define PORT_ADC0 	PORTF
+#define PIN_ADC0  	PINF
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRF
+#define PORT_ADC1 	PORTF
+#define PIN_ADC1  	PINF
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRF
+#define PORT_ADC2 	PORTF
+#define PIN_ADC2  	PINF
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRF
+#define PORT_ADC3 	PORTF
+#define PIN_ADC3  	PINF
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRF
+#define PORT_ADC4 	PORTF
+#define PIN_ADC4  	PINF
+#define ADC4_IDX  	4
+
+#define DDR_ADC5  	DDRF
+#define PORT_ADC5 	PORTF
+#define PIN_ADC5  	PINF
+#define ADC5_IDX  	5
+
+#define DDR_ADC6  	DDRF
+#define PORT_ADC6 	PORTF
+#define PIN_ADC6  	PINF
+#define ADC6_IDX  	6
+
+#define DDR_ADC7  	DDRF
+#define PORT_ADC7 	PORTF
+#define PIN_ADC7  	PINF
+#define ADC7_IDX  	7
+
+#define DDR_WR  	DDRG
+#define PORT_WR 	PORTG
+#define PIN_WR  	PING
+#define WR_IDX  	0
+
+#define DDR_RD  	DDRG
+#define PORT_RD 	PORTG
+#define PIN_RD  	PING
+#define RD_IDX  	1
+
+#define DDR_ALE  	DDRG
+#define PORT_ALE 	PORTG
+#define PIN_ALE  	PING
+#define ALE_IDX  	2
+
+
 #endif /* _AVR_IOM64_H_ */
Index: include/avr/iom329.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom329.h,v
retrieving revision 1.14
diff -u -r1.14 iom329.h
--- include/avr/iom329.h	11 Feb 2009 17:53:36 -0000	1.14
+++ include/avr/iom329.h	26 Mar 2009 20:10:30 -0000
@@ -1,5 +1,6 @@
 /* Copyright (c) 2004 Eric B. Weddington
    Copyright (c) 2005, 2006, 2007 Anatoly Sokolov 
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -856,90 +857,112 @@
 /* Interrupt vectors */
 /* Vector 0 is the reset vector */
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* Pin Change Interrupt Request 0 */
+#define PCINT0_num 			2
 #define PCINT0_vect			_VECTOR(2)
 #define SIG_PIN_CHANGE0			_VECTOR(2)
 
 /* Pin Change Interrupt Request 1 */
+#define PCINT1_num 			3
 #define PCINT1_vect			_VECTOR(3)
 #define SIG_PIN_CHANGE1			_VECTOR(3)
 
 /* Timer/Counter2 Compare Match */
+#define TIMER2_COMP_num 		4
 #define TIMER2_COMP_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE2		_VECTOR(4)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			5
 #define TIMER2_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW2			_VECTOR(5)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		6
 #define TIMER1_CAPT_vect		_VECTOR(6)
 #define SIG_INPUT_CAPTURE1		_VECTOR(6)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		7
 #define TIMER1_COMPA_vect		_VECTOR(7)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(7)
 
 /* Timer/Counter Compare Match B */
+#define TIMER1_COMPB_num 		8
 #define TIMER1_COMPB_vect		_VECTOR(8)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(8)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			9
 #define TIMER1_OVF_vect			_VECTOR(9)
 #define SIG_OVERFLOW1			_VECTOR(9)
 
 /* Timer/Counter0 Compare Match */
+#define TIMER0_COMP_num 		10
 #define TIMER0_COMP_vect		_VECTOR(10)
 #define SIG_OUTPUT_COMPARE0		_VECTOR(10)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			11
 #define TIMER0_OVF_vect			_VECTOR(11)
 #define SIG_OVERFLOW0			_VECTOR(11)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num 			12
 #define SPI_STC_vect			_VECTOR(12)
 #define SIG_SPI				_VECTOR(12)
 
 /* USART0, Rx Complete */
+#define USART0_RX_num 			13
 #define USART0_RX_vect			_VECTOR(13)
 #define SIG_UART_RECV			_VECTOR(13)
 
 /* USART0 Data register Empty */
+#define USART0_UDRE_num 		14
 #define USART0_UDRE_vect		_VECTOR(14)
 #define SIG_UART_DATA			_VECTOR(14)
 
 /* USART0, Tx Complete */
+#define USART0_TX_num 			15
 #define USART0_TX_vect			_VECTOR(15)
 #define SIG_UART_TRANS			_VECTOR(15)
 
 /* USI Start Condition */
+#define USI_START_num 			16
 #define USI_START_vect			_VECTOR(16)
 #define SIG_USI_START			_VECTOR(16)
 
 /* USI Overflow */
+#define USI_OVERFLOW_num 		17
 #define USI_OVERFLOW_vect		_VECTOR(17)
 #define SIG_USI_OVERFLOW		_VECTOR(17)
 
 /* Analog Comparator */
+#define ANALOG_COMP_num 		18
 #define ANALOG_COMP_vect		_VECTOR(18)
 #define SIG_COMPARATOR			_VECTOR(18)
 
 /* ADC Conversion Complete */
+#define ADC_num 			19
 #define ADC_vect			_VECTOR(19)
 #define SIG_ADC				_VECTOR(19)
 
 /* EEPROM Ready */
+#define EE_READY_num 			20
 #define EE_READY_vect			_VECTOR(20)
 #define SIG_EEPROM_READY		_VECTOR(20)
 
 /* Store Program Memory Read */
+#define SPM_READY_num 			21
 #define SPM_READY_vect			_VECTOR(21)
 #define SIG_SPM_READY			_VECTOR(21)
 
 /* LCD Start of Frame */
+#define LCD_num 			22
 #define LCD_vect			_VECTOR(22)
 #define SIG_LCD				_VECTOR(22)
 
@@ -1000,4 +1023,371 @@
 #define SIGNATURE_2 0x03
 
 
+/* Device Pin Definitions */
+#define DDR_COM0  	DDRA
+#define PORT_COM0 	PORTA
+#define PIN_COM0  	PINA
+#define COM0_IDX  	0
+
+#define DDR_COM1  	DDRA
+#define PORT_COM1 	PORTA
+#define PIN_COM1  	PINA
+#define COM1_IDX  	1
+
+#define DDR_COM2  	DDRA
+#define PORT_COM2 	PORTA
+#define PIN_COM2  	PINA
+#define COM2_IDX  	2
+
+#define DDR_COM3  	DDRA
+#define PORT_COM3 	PORTA
+#define PIN_COM3  	PINA
+#define COM3_IDX  	3
+
+#define DDR_SEG0  	DDRA
+#define PORT_SEG0 	PORTA
+#define PIN_SEG0  	PINA
+#define SEG0_IDX  	4
+
+#define DDR_SEG1  	DDRA
+#define PORT_SEG1 	PORTA
+#define PIN_SEG1  	PINA
+#define SEG1_IDX  	5
+
+#define DDR_SEG2  	DDRA
+#define PORT_SEG2 	PORTA
+#define PIN_SEG2  	PINA
+#define SEG2_IDX  	6
+
+#define DDR_SEG3  	DDRA
+#define PORT_SEG3 	PORTA
+#define PIN_SEG3  	PINA
+#define SEG3_IDX  	7
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	0
+
+#define DDR_PCINT8  	DDRB
+#define PORT_PCINT8 	PORTB
+#define PIN_PCINT8  	PINB
+#define PCINT8_IDX  	0
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	1
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	1
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	2
+
+#define DDR_PCINT10  	DDRB
+#define PORT_PCINT10 	PORTB
+#define PIN_PCINT10  	PINB
+#define PCINT10_IDX  	2
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	3
+
+#define DDR_PCINT11  	DDRB
+#define PORT_PCINT11 	PORTB
+#define PIN_PCINT11  	PINB
+#define PCINT11_IDX  	3
+
+#define DDR_OC0  	DDRB
+#define PORT_OC0 	PORTB
+#define PIN_OC0  	PINB
+#define OC0_IDX  	4
+
+#define DDR_PCINT12  	DDRB
+#define PORT_PCINT12 	PORTB
+#define PIN_PCINT12  	PINB
+#define PCINT12_IDX  	4
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	5
+
+#define DDR_PCINT13  	DDRB
+#define PORT_PCINT13 	PORTB
+#define PIN_PCINT13  	PINB
+#define PCINT13_IDX  	5
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	6
+
+#define DDR_PCINT14  	DDRB
+#define PORT_PCINT14 	PORTB
+#define PIN_PCINT14  	PINB
+#define PCINT14_IDX  	6
+
+#define DDR_OC2  	DDRB
+#define PORT_OC2 	PORTB
+#define PIN_OC2  	PINB
+#define OC2_IDX  	7
+
+#define DDR_PCINT15  	DDRB
+#define PORT_PCINT15 	PORTB
+#define PIN_PCINT15  	PINB
+#define PCINT15_IDX  	7
+
+#define DDR_SEG12  	DDRC
+#define PORT_SEG12 	PORTC
+#define PIN_SEG12  	PINC
+#define SEG12_IDX  	0
+
+#define DDR_SEG11  	DDRC
+#define PORT_SEG11 	PORTC
+#define PIN_SEG11  	PINC
+#define SEG11_IDX  	1
+
+#define DDR_SEG10  	DDRC
+#define PORT_SEG10 	PORTC
+#define PIN_SEG10  	PINC
+#define SEG10_IDX  	2
+
+#define DDR_SEG9  	DDRC
+#define PORT_SEG9 	PORTC
+#define PIN_SEG9  	PINC
+#define SEG9_IDX  	3
+
+#define DDR_SEG8  	DDRC
+#define PORT_SEG8 	PORTC
+#define PIN_SEG8  	PINC
+#define SEG8_IDX  	4
+
+#define DDR_SEG7  	DDRC
+#define PORT_SEG7 	PORTC
+#define PIN_SEG7  	PINC
+#define SEG7_IDX  	5
+
+#define DDR_SEG6  	DDRC
+#define PORT_SEG6 	PORTC
+#define PIN_SEG6  	PINC
+#define SEG6_IDX  	6
+
+#define DDR_SEG5  	DDRC
+#define PORT_SEG5 	PORTC
+#define PIN_SEG5  	PINC
+#define SEG5_IDX  	7
+
+#define DDR_ICP/SEG22  	DDRD
+#define PORT_ICP/SEG22 	PORTD
+#define PIN_ICP/SEG22  	PIND
+#define ICP/SEG22_IDX  	0
+
+#define DDR_INT0/SEG21  	DDRD
+#define PORT_INT0/SEG21 	PORTD
+#define PIN_INT0/SEG21  	PIND
+#define INT0/SEG21_IDX  	1
+
+#define DDR_SEG20  	DDRD
+#define PORT_SEG20 	PORTD
+#define PIN_SEG20  	PIND
+#define SEG20_IDX  	2
+
+#define DDR_SEG19  	DDRD
+#define PORT_SEG19 	PORTD
+#define PIN_SEG19  	PIND
+#define SEG19_IDX  	3
+
+#define DDR_SEG18  	DDRD
+#define PORT_SEG18 	PORTD
+#define PIN_SEG18  	PIND
+#define SEG18_IDX  	4
+
+#define DDR_SEG17  	DDRD
+#define PORT_SEG17 	PORTD
+#define PIN_SEG17  	PIND
+#define SEG17_IDX  	5
+
+#define DDR_SEG16  	DDRD
+#define PORT_SEG16 	PORTD
+#define PIN_SEG16  	PIND
+#define SEG16_IDX  	6
+
+#define DDR_SEG15  	DDRD
+#define PORT_SEG15 	PORTD
+#define PIN_SEG15  	PIND
+#define SEG15_IDX  	7
+
+#define DDR_RXD  	DDRE
+#define PORT_RXD 	PORTE
+#define PIN_RXD  	PINE
+#define RXD_IDX  	0
+
+#define DDR_PCINT0  	DDRE
+#define PORT_PCINT0 	PORTE
+#define PIN_PCINT0  	PINE
+#define PCINT0_IDX  	0
+
+#define DDR_TXD  	DDRE
+#define PORT_TXD 	PORTE
+#define PIN_TXD  	PINE
+#define TXD_IDX  	1
+
+#define DDR_PCINT1  	DDRE
+#define PORT_PCINT1 	PORTE
+#define PIN_PCINT1  	PINE
+#define PCINT1_IDX  	1
+
+#define DDR_XCK  	DDRE
+#define PORT_XCK 	PORTE
+#define PIN_XCK  	PINE
+#define XCK_IDX  	2
+
+#define DDR_AIN0  	DDRE
+#define PORT_AIN0 	PORTE
+#define PIN_AIN0  	PINE
+#define AIN0_IDX  	2
+
+#define DDR_PCINT2  	DDRE
+#define PORT_PCINT2 	PORTE
+#define PIN_PCINT2  	PINE
+#define PCINT2_IDX  	2
+
+#define DDR_AIN1  	DDRE
+#define PORT_AIN1 	PORTE
+#define PIN_AIN1  	PINE
+#define AIN1_IDX  	3
+
+#define DDR_PCINT3  	DDRE
+#define PORT_PCINT3 	PORTE
+#define PIN_PCINT3  	PINE
+#define PCINT3_IDX  	3
+
+#define DDR_USCK  	DDRE
+#define PORT_USCK 	PORTE
+#define PIN_USCK  	PINE
+#define USCK_IDX  	4
+
+#define DDR_SCL  	DDRE
+#define PORT_SCL 	PORTE
+#define PIN_SCL  	PINE
+#define SCL_IDX  	4
+
+#define DDR_PCINT4  	DDRE
+#define PORT_PCINT4 	PORTE
+#define PIN_PCINT4  	PINE
+#define PCINT4_IDX  	4
+
+#define DDR_DI  	DDRE
+#define PORT_DI 	PORTE
+#define PIN_DI  	PINE
+#define DI_IDX  	5
+
+#define DDR_SDA  	DDRE
+#define PORT_SDA 	PORTE
+#define PIN_SDA  	PINE
+#define SDA_IDX  	5
+
+#define DDR_PCINT5  	DDRE
+#define PORT_PCINT5 	PORTE
+#define PIN_PCINT5  	PINE
+#define PCINT5_IDX  	5
+
+#define DDR_DO  	DDRE
+#define PORT_DO 	PORTE
+#define PIN_DO  	PINE
+#define DO_IDX  	6
+
+#define DDR_PCINT6  	DDRE
+#define PORT_PCINT6 	PORTE
+#define PIN_PCINT6  	PINE
+#define PCINT6_IDX  	6
+
+#define DDR_PCINT7  	DDRE
+#define PORT_PCINT7 	PORTE
+#define PIN_PCINT7  	PINE
+#define PCINT7_IDX  	7
+
+#define DDR_ADC0  	DDRF
+#define PORT_ADC0 	PORTF
+#define PIN_ADC0  	PINF
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRF
+#define PORT_ADC1 	PORTF
+#define PIN_ADC1  	PINF
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRF
+#define PORT_ADC2 	PORTF
+#define PIN_ADC2  	PINF
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRF
+#define PORT_ADC3 	PORTF
+#define PIN_ADC3  	PINF
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRF
+#define PORT_ADC4 	PORTF
+#define PIN_ADC4  	PINF
+#define ADC4_IDX  	4
+
+#define DDR_ADC5  	DDRF
+#define PORT_ADC5 	PORTF
+#define PIN_ADC5  	PINF
+#define ADC5_IDX  	5
+
+#define DDR_ADC6  	DDRF
+#define PORT_ADC6 	PORTF
+#define PIN_ADC6  	PINF
+#define ADC6_IDX  	6
+
+#define DDR_ADC7  	DDRF
+#define PORT_ADC7 	PORTF
+#define PIN_ADC7  	PINF
+#define ADC7_IDX  	7
+
+#define DDR_SEG14  	DDRG
+#define PORT_SEG14 	PORTG
+#define PIN_SEG14  	PING
+#define SEG14_IDX  	0
+
+#define DDR_SEG13  	DDRG
+#define PORT_SEG13 	PORTG
+#define PIN_SEG13  	PING
+#define SEG13_IDX  	1
+
+#define DDR_SEG4  	DDRG
+#define PORT_SEG4 	PORTG
+#define PIN_SEG4  	PING
+#define SEG4_IDX  	2
+
+#define DDR_T1  	DDRG
+#define PORT_T1 	PORTG
+#define PIN_T1  	PING
+#define T1_IDX  	3
+
+#define DDR_SEG24  	DDRG
+#define PORT_SEG24 	PORTG
+#define PIN_SEG24  	PING
+#define SEG24_IDX  	3
+
+#define DDR_T0  	DDRG
+#define PORT_T0 	PORTG
+#define PIN_T0  	PING
+#define T0_IDX  	4
+
+#define DDR_SEG23  	DDRG
+#define PORT_SEG23 	PORTG
+#define PIN_SEG23  	PING
+#define SEG23_IDX  	4
+
+
 #endif /* _AVR_IOM329_H_ */
Index: include/avr/io4433.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/io4433.h,v
retrieving revision 1.13
diff -u -r1.13 io4433.h
--- include/avr/io4433.h	11 Feb 2009 17:53:34 -0000	1.13
+++ include/avr/io4433.h	26 Mar 2009 20:10:21 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -180,54 +181,67 @@
 /* Interrupt vectors */
 
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* Timer/Counter Capture Event */
+#define TIMER1_CAPT_num 		3
 #define TIMER1_CAPT_vect		_VECTOR(3)
 #define SIG_INPUT_CAPTURE1		_VECTOR(3)
 
 /* Timer/Counter1 Compare Match */
+#define TIMER1_COMP_num 		4
 #define TIMER1_COMP_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(4)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			5
 #define TIMER1_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW1			_VECTOR(5)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			6
 #define TIMER0_OVF_vect			_VECTOR(6)
 #define SIG_OVERFLOW0			_VECTOR(6)
 
 /* Serial Transfer Complete */
+#define SPI_STC_num 			7
 #define SPI_STC_vect			_VECTOR(7)
 #define SIG_SPI				_VECTOR(7)
 
 /* UART, Rx Complete */
+#define UART_RX_num 			8
 #define UART_RX_vect			_VECTOR(8)
 #define SIG_UART_RECV			_VECTOR(8)
 
 /* UART Data Register Empty */
+#define UART_UDRE_num 			9
 #define UART_UDRE_vect			_VECTOR(9)
 #define SIG_UART_DATA			_VECTOR(9)
 
 /* UART, Tx Complete */
+#define UART_TX_num 			10
 #define UART_TX_vect			_VECTOR(10)
 #define SIG_UART_TRANS			_VECTOR(10)
 
 /* ADC Conversion Complete */
+#define ADC_num 			11
 #define ADC_vect			_VECTOR(11)
 #define SIG_ADC				_VECTOR(11)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			12
 #define EE_RDY_vect			_VECTOR(12)
 #define SIG_EEPROM_READY		_VECTOR(12)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			13
 #define ANA_COMP_vect			_VECTOR(13)
 #define SIG_COMPARATOR			_VECTOR(13)
 
@@ -470,4 +484,106 @@
 #define SIGNATURE_2 0x03
 
 
+/* Device Pin Definitions */
+#define DDR_ICP  	DDRB
+#define PORT_ICP 	PORTB
+#define PIN_ICP  	PINB
+#define ICP_IDX  	0
+
+#define DDR_OC1  	DDRB
+#define PORT_OC1 	PORTB
+#define PIN_OC1  	PINB
+#define OC1_IDX  	1
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	2
+
+#define DDR_MOS1  	DDRB
+#define PORT_MOS1 	PORTB
+#define PIN_MOS1  	PINB
+#define MOS1_IDX  	3
+
+#define DDR_MOS0  	DDRB
+#define PORT_MOS0 	PORTB
+#define PIN_MOS0  	PINB
+#define MOS0_IDX  	4
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	5
+
+#define DDR_ADC0  	DDRC
+#define PORT_ADC0 	PORTC
+#define PIN_ADC0  	PINC
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRC
+#define PORT_ADC1 	PORTC
+#define PIN_ADC1  	PINC
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRC
+#define PORT_ADC2 	PORTC
+#define PIN_ADC2  	PINC
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRC
+#define PORT_ADC3 	PORTC
+#define PIN_ADC3  	PINC
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRC
+#define PORT_ADC4 	PORTC
+#define PIN_ADC4  	PINC
+#define ADC4_IDX  	4
+
+#define DDR_ADC5  	DDRC
+#define PORT_ADC5 	PORTC
+#define PIN_ADC5  	PINC
+#define ADC5_IDX  	5
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_T0  	DDRD
+#define PORT_T0 	PORTD
+#define PIN_T0  	PIND
+#define T0_IDX  	4
+
+#define DDR_T1  	DDRD
+#define PORT_T1 	PORTD
+#define PIN_T1  	PIND
+#define T1_IDX  	5
+
+#define DDR_AIN0  	DDRD
+#define PORT_AIN0 	PORTD
+#define PIN_AIN0  	PIND
+#define AIN0_IDX  	6
+
+#define DDR_AIN1  	DDRD
+#define PORT_AIN1 	PORTD
+#define PIN_AIN1  	PIND
+#define AIN1_IDX  	7
+
+
 #endif /* _AVR_IO4433_H_ */
